#!/bin/sh
###
### clapf_admin.sh
###

SQLPROG='/usr/bin/sqlite3 /var/lib/clapf/data/tokens.sdb'

if [ $# -lt 2 ]; then
	echo; echo "usage: $0 <action> <uid> <gid> <username> <realname> <encrypted password> <email address> <domain> <policy group id>"; echo
	echo "eg. #1: $0 add 1001 1001 jim 'Jim Bim' '"'$1$AQ9XPn$k9zHvBRo.AXPQRkM7HkX2.'"' jim@aaaa.fu aaaa.fu 0"
	echo "eg. #2: $0 del 1001"; echo
	exit 1;
fi

action=$1
uid=$2
gid=$3
username=$4
realname=$5
encrypted_password=$6
email=$7
domain=$8
poliy_group_id=$9

CMD=""




### check parameters ###

# some numeric fields

x=`echo $uid | tr -cd [:digit:]`
if [ "$x" != "$uid" ]; then echo "invalid uid: $uid"; exit; fi

x=`echo $gid | tr -cd [:digit:]`
if [ "$x" != "$gid" ]; then echo "invalid gid: $gid"; exit; fi

x=`echo $poliy_group_id | tr -cd [:digit:]`
if [ "$x" != "$poliy_group_id" ]; then echo "invalid policy group id: $poliy_group_id"; exit; fi

# username may contain alphanumeric characters

x=`echo $username | tr -cd [:alnum:]`
if [ "$x" != "$username" ]; then echo "invalid username: $username"; exit; fi

x=`echo $realname | tr -cd [:alnum:][@_\.\ ]`
if [ "$x" != "$realname" ]; then echo "invalid realname: $realname"; exit; fi

# email and domain may contain alphanumeric characters + '.', '@', '-', '_'

x=`echo $email | tr -cd -- -[:alnum:][@_.]`
if [ "$x" != "$email" ]; then echo "invalid email: $email"; exit; fi

x=`echo $domain | tr -cd -- -[:alnum:][@_.]`
if [ "$x" != "$domain" ]; then echo "invalid domain: $domain"; exit; fi

# encrypted password may contain alphanumeric characters + '$', '/', '.'

x=`echo $encrypted_password | tr -cd [:alnum:][\/\$\.]`
if [ "$x" != "$encrypted_password" ]; then echo "invalid encrypted password: $encrypted_password"; exit; fi





if test $# -eq 6 && test "$action" = "add" ; then
	CMD=`( echo "INSERT INTO t_misc (nham, nspam, gid) VALUES (0, 0, $gid);" 
	echo "INSERT INTO user (uid, gid, username, realname, password, domain, policy_group, isadmin) VALUES ($uid, $gid, '$username', '$realname', '$encrypted_password', '$domain', $poliy_group_id, 0);" 
	echo "INSERT INTO t_email (uid, email) VALUES ($uid, '$email');" 
	echo "INSERT INTO t_white_list (uid) VALUES ($uid);" 
	echo "INSERT INTO t_black_list (uid) VALUES ($uid);" )`
fi


if test $# -eq 2 && test "$action" = "del" ; then
	CMD=`( echo "DELETE FROM user WHERE uid=$uid;"
	echo "DELETE FROM t_email WHERE uid=$uid;"
	echo "DELETE FROM t_white_list WHERE uid=$uid;"
	echo "DELETE FROM t_black_list WHERE uid=$uid;" )`
fi


if test "x" != "x$CMD"; then
	echo $CMD | $SQLPROG
fi

